<?php
require_once("/www/cgi-bin/inc/define.inc");

//AQL
require_once("/www/cgi-bin/inc/aql.php");

function __cut_str($str,$start_str,$end_str)
{
	if(! ($find_start=strpos($str,$start_str))) {
		return "";
	}
	
	if(! ($find_end=strpos($str,$end_str))) {
		return "";
	}
	
	$start_pos = $find_start + strlen($start_str);
	
	if(($c_str_l = $find_end - $start_pos) <= 0) {
		return "";
	}
 
   return substr($str,$start_pos,$c_str_l);    
}


function ast_reload()
{
	exec("asterisk -rx \"core reload\" & > /dev/null 2>&1");
}

function ast_dialplan_reload()
{
	exec("asterisk -rx \"dialplan reload\" & > /dev/null 2>&1");
}

function sip_reload()
{
	exec("asterisk -rx \"sip reload\" & > /dev/null 2>&1");
}

function manager_reload()
{
	exec("asterisk -rx \"manager reload\" & > /dev/null 2>&1");
}

function execute_astcmd($command)
{
	$ret_str = '';
	$command = trim($command);
	$command = ltrim($command,'!');

	$command = str_replace("\"","\\\\\\\"",$command);

	if(strcasecmp($command,"help") == 0 || $command == '?' ) {
		$command = 'core show help';
	} 

	if($command != '') {
		$ast_cmd = "asterisk -rx \"$command\"";
		$file = popen($ast_cmd,"r");
		while(!feof($file)) {
			$line = fgets($file);
			$ret_str .= $line."<br/>";
			//ob_flush();
			//flush();
		}
		pclose($file);
	}

	return $ret_str;
}

/*
*
* Set Speaker volume level
* level 0-100
*/
function set_slevel($span,$level)
{
	exec("asterisk -rx \"gsm send at $span \"AT+CLVL=$level\"\" > /dev/null 2>&1 ");
}

/*
*
* Set Microphone gain level
* level: 0-15
*/
function set_mlevel($span,$level)
{
	exec("asterisk -rx \"gsm send at $span \"AT+CMIC=0,$level\"\" > /dev/null 2>&1 ");
}


/*
*
* Set soft rx gain 
*/
function set_srxgain($span, $value)
{
	$chan = ($span * 2) - 1;
	exec("asterisk -rx \"extra set swgain rx $chan $value\" > /dev/null 2>&1 ");
}


/*
*
* Set soft tx gain 
*/
function set_stxgain($span, $value)
{
	$chan = ($span * 2) - 1;
	exec("asterisk -rx \"extra set swgain tx $chan $value\" > /dev/null 2>&1 ");
}

/*
*
* Get GSM Name
*
*/
function get_gsmname($span)
{	
	$aql = new aql();

	$setok = $aql->set('basedir','/etc/asterisk');
	if (!$setok) {
		echo __LINE__.' '.$aql->get_error();
		return;
	}

	$hlock = lock_file('/etc/asterisk/gw_gsm.conf');
	$result = $aql->query("select * from gw_gsm.conf where section='$span'");
	unlock_file($hlock);

	if ($result == false) {
		return '';
	}

	if(isset($result[$span]['name'])) {
		return trim($result[$span]['name']); 
	}

	return '';
}

function lock_file($file_path)
{
	$new_name = str_replace("/","_",$file_path);
	$lock_path = "/tmp/" . $new_name . ".lock";
	$fh = fopen($lock_path, "w+");
	if($fh <= 0) {
		return -1;
	}
	flock($fh,LOCK_EX);

	return $fh;
}

function unlock_file($fh)
{
	if($fh > 0) {
		flock($fh,LOCK_UN);
		fclose($fh);
	}
}


function bytesConvert($bytes)
{
	$ext = array('B', 'kB', 'MB', 'GB', 'TB', 'PB', 'EB', 'ZB', 'YB');
	$unitCount = 0;
	for(; $bytes > 1024; $unitCount++) $bytes /= 1024;
	return round($bytes,2) ." ". $ext[$unitCount];
}

function get_dns()
{
	$dns_file="/etc/resolv.conf";

	$ret=NULL;

	if(file_exists($dns_file)) {
		$fh=fopen($dns_file,"r");
		while(!feof($fh) && ($line = fgets($fh))) {
			if(substr($line,0,10) == "nameserver") {
				$dns=substr($line,10,strlen($line)-10);
				$dns=trim($dns);
				if(preg_match("/^((2[0-4][0-9]|25[0-5]|[01]?[0-9][0-9]?)\.){3}(2[0-4][0-9]|25[0-5]|[01]?[0-9][0-9]?)$/",$dns)) {
					$ret[]=$dns;
				}
			}
		}
	}

	return $ret;
}


function echo_saved()
{
	echo "<img src= \"../../images/action_ok.gif\"><font color=00FF00>Saved</font>";
}


function get_sip_registrys()
{
	$ret = array();

	$reg=`asterisk -rx "sip show registry"`;
	if(!empty($reg)) {

/* Format
Host                                    dnsmgr Username       Refresh State                Reg.Time \n
172.16.47.243:5060                      | N      | 101          |      120 | Request Sent         | \n
172.16.70.121:5060                      | N      | 101          |      105 | Registered           | Thu, 01 Jan 1970 06:49:37\n
2 SIP registrations.\n
\n 
*/ 
		$line = explode("\n",$reg);
		if(!empty($line)) {
			$a = 0;
			//Don't need first line and last 2 lines.
			$line_len = count($line) - 2;
			for($i=1; $i < $line_len; $i++) {
				$item = explode("|",$line[$i],6);
				if(isset($item[0]) && isset($item[2]) && isset($item[4])) {
					$host_and_port = trim($item[0]);
					$temp = explode(":",$host_and_port);
					if(isset($temp[0]))
						$host = $temp[0];
					else
						continue;

					$user = trim($item[2]);

					$status = trim($item[4]);

					//if($status == 'Registered') {
						$ret[$a]['host'] = $host;
						$ret[$a]['username'] = $user;
						$ret[$a]['status'] = $status;
						$a++;
					//}
				}
			}
		}
	}

	return $ret;
}


function get_sip_peers()
{
	$ret = array();

	$reg=`asterisk -rx "sip show peers"`;
	if(!empty($reg)) {

/* Format
Name/username              Host                                    Dyn Forcerport ACL Port     Status\n
101-172.16.70.121/101     | 172.16.70.121                           |     |  N  |     | 5060     | Unmonitored |\n
1 sip peers [Monitored: 0 online, 0 offline Unmonitored: 1 online, 0 offline]\n
*/ 
		$line = explode("\n",$reg);
		if(!empty($line)) {
			$a = 0;
			//Don't need first line and last 2 lines.
			$line_len = count($line) - 2;
			for($i=1; $i < $line_len; $i++) {
				$item = explode("|",$line[$i],8);
				if(isset($item[0]) && isset($item[1]) && isset($item[2]) && isset($item[6])) {
					$context_and_name = trim($item[0]);
					$temp = explode("/",$context_and_name);
					if(isset($temp[1]))
						$name = $temp[1];
					else
						continue;

					$host = trim($item[1]);
					$dyn = trim($item[2]);
					$status = trim($item[6]);

					if($dyn == 'D') {
						$ret[$a]['username'] = $name;
						$ret[$a]['host'] = $host;
						$ret[$a]['status'] = $status;
						$a++;
					}
				}
			}
		}
	}

	return $ret;
}


function parse_register($register)
{
	//register => [peer?][transport://]user[@domain][:secret[:authuser]]@host[:port][/extension][~expiry]

	$ary = explode('@',$register);
	if(count($ary) == 2) {  // $register = [peer?][transport://]user[:secret[:authuser]]@host[:port][/extension][~expiry]
		$part1 = $ary[0];  // $part1 = [peer?][transport://]user[:secret[:authuser]]
		$part2 = $ary[1];  //$part2 = host[:port][/extension][~expiry]
		$ary = explode('?',$part1);
		if(count($ary) == 2) { //$part1 = peer?[transport://]user[:secret[:authuser]]
			$reg['peer'] = $ary[0];  //peer
			$part22 = $ary[1];  // $part22 = [transport://]user[:secret[:authuser]]
			$ary = explode('://',$part22);
			if(count($ary) == 2) { //$part22 = transport://user[:secret[:authuser]]
				$reg['transport'] = $ary[0];  //transport
				$part222 = $ary[1];  //$part222 = user[:secret[:authuser]]
				$ary = explode(':',$part222);
				if(count($ary) == 2) {   //$part222 = user:secret
					$reg['user'] = $ary[0];   //user
					$reg['secret'] = $ary[1]; //secret
				} else if(count($ary) == 3) {  //$part222 = user:secret:authuser
					$reg['user'] = $ary[0];   //user
					$reg['secret'] = $ary[1];  //secret
					$reg['authuser'] = $ary[2]; //authuser
				} else if(count($ary) == 1) { //$part222 = user
					$reg_use = $part222;
				}
			} else if(count($ary) == 1) {  //$part22 = user[:secret[:authuser]]
				$ary = explode(':',$part22);
				if(count($ary) == 2) { // $part22 = user:secret
					$reg['user'] = $ary[0];
					$reg['secret'] = $ary[1];
				} else if(count($ary) == 3) { //$part22 = user:secret:authuser
					$reg['user'] = $ary[0];
					$reg['secret'] = $ary[1];
					$reg['authuser'] = $ary[2];
				} else if(count($ary) == 1) { //$part22 = user
					$reg['user'] = $part22;
				}
			}
		} else if(count($ary) == 1) {  // $part1 = [transport://]user[:secret[:authuser]]
			$ary = explode('://',$part1);
			if(count($ary) == 2) {   // $part1 = transport://user[:secret[:authuser]]
				$reg['transport'] = $ary[0];
				$part22 = $ary[1];   //$part22 = user[:secret[:authuser]]
			} else if(count($ary) == 1) {  //$part1 = user[:secret[:authuser]]
				$ary = explode(':',$part1);
				if(count($ary) == 2) { // $part1 = user:secret
					$reg['user'] = $ary[0];
					$reg['secret'] = $ary[1];
				} else if(count($ary) == 3) { //$part1 = user:secret:authuser
					$reg['user'] = $ary[0];
					$reg['secret'] = $ary[1];
					$reg['authuser'] = $ary[2];
				} else if(count($ary) == 1) { //$part1 = user
					$reg['user'] = $part1;
				}
			}
		}
	
		$ary = explode(':',$part2);
		if(count($ary) == 2) {  //$part2 = host:port[/extension][~expiry]
			$reg['host'] = $ary[0];  //host
			$part22 = $ary[1];     //$part22 = port[/extension][~expiry]
			$ary = explode('/',$part22);
			if(count($ary) == 2) { //$part22 = port/extension[~expiry] 
				$reg['port'] = $ary[0];  //port
				$part222 = $ary[1];     //$part222 = extension[~expiry]
				$ary = explode('~',$part222);
				if(count($ary) == 2) {  //$part222 = extension~expiry
					$reg['extension'] = $ary[0];  //extension
					$reg['expiry'] = $ary[1];     //~expiry
				} else if(count($ary) == 1) { //$part2 = extension
					$reg['extension'] = $part222;  //extension
				}
			} else if(count($ary) == 1) { //$part22 = port[~expiry]
				$ary = explode('~',$part22);
				if(count($ary) == 2) { //$part22 = port~expiry
					$reg['port'] = $ary[0];
					$reg['expiry'] = $ary[1];
				} else if(count($ary) == 1) { //$part22 = port
					$reg['port'] = $part22;
				}
			}
		} else if(count($ary) == 1) {  // $part2 = host[/extension][~expiry]
			$ary = explode('/',$part2);
			if(count($ary) == 2) { //$part2 = host/extension[~expiry]
				$reg['host'] = $ary[0];  //host
				$part22 = $ary[1]; // $part22 = extension[~expiry]
				$ary = explode('~',$part22);
				if(count($ary) == 2) { //$part22 = extension~expiry
					$reg['extension'] = $ary[0];
					$reg['expiry'] = $ary[1];
				} else if(count($ary) == 1) { //$part22 = extension
					$reg['extension'] = $part22;
				}
			} else if(count($ary) == 1) { //$part2 = host[~expiry]
				$ary = explode('~',$part2);
				if(count($ary) == 2) {  //$part2 = host~expiry
					$reg['host'] = $ary[0];
					$reg['expiry'] = $ary[1];
				} else if(count($ary) == 1) { //$part2 =host
					$reg['host'] = $part2;
				}
			}
		}
	} else if((count($ary) == 3)) { //  $register = [peer?][transport://]user@domain[:secret[:authuser]]@host[:port][/extension][~expiry]
		$part1 = $ary[0];  //$part1 = [peer?][transport://]user
		$part2 = $ary[1];  //$part2 = domain[:secret[:authuser]]
		$part3 = $ary[2];  // $part3= host[:port][/extension][~expiry]
		$ary = explode('?',$part1);
		if(count($ary) == 2) { //$part1 = peer?[transport://]user
			$reg['peer'] = $ary[0]; // peer
			$part22 = $ary[1];   //$part22 = [transport://]user
			$ary = explode('://',$part22);
			if(count($ary) == 2) { //$part22 = transport://user 
				$reg['transport'] = $ary[0];
				$reg['user'] = $ary[1];
			} else if(count($ary) == 1){ //$part22 = user
				$reg['user'] = $part22;
			}
		} else if(count($ary) == 1) { // $part1 = [transport://]user
			$ary = explode('://',$part1);
			if(count($ary) == 2) { // $part1 = transport://user
				$reg['transport'] = $ary[0];
				$reg['user'] = $ary[1];
			} else if(count($ary) == 1) { //$part1 = user
				$reg['user'] = $part1;
			}
		}

		$ary = explode(':',$part2);
		if(count($ary) == 3) {  // $part2 = domain:secret:authuser
			$reg['domain'] = $ary[0];
			$reg['secret'] = $ary[1];
			$reg['authuser'] = $ary[2];
		} else if(count($ary) == 2) {  //$part2 = domain:secret
			$reg['domain'] = $ary[0];
			$reg['secret'] = $ary[1];
		} else if(count($ary) == 1) { //$part2 = domain
			$reg['domain'] = $part2;
		}

		$ary = explode(':',$part3);
		if(count($ary) == 2) { // $part3 = host:port[/extension][~expiry]
			$reg['host'] = $ary[0];  //host
			$part22 = $ary[1]; // $part22 = port[/extension][~expiry]
			$ary = explode('/',$part22);
			if(count($ary) == 2) {  // $part3 = port/extension[~expiry]
				$reg['port'] = $ary[0];  //port
				$part222 = $ary[1]; // $part222 = extension[~expiry]
				$ary = explode('~',$part222);
				if(count($ary) == 2) { // $part222 = extension~expiry
					$reg['extension'] = $ary[0]; //extension
					$reg['expiry'] = $ary[1];  //expiry
				} else if(count($ary) == 1) { // $part222 = extension
					$reg['extension'] = $part222;
				}
			} else if(count($ary) == 1) { //$part22 = port[~expiry]
				$ary = explode('~',$part22);
				if(count($ary) == 2) { //$part22 = port~expiry
					$reg['port'] = $ary[0];
					$reg['expiry'] = $ary[1];
				} else if(count($ary) == 1) { //$part22 = port
					$reg['port'] = $part22;
				}
			}
		} else if(count($ary) == 1) { //$part3 = host[/extension][~expiry]
			$ary = explode('/',$part3);
			if(count($ary) == 2) { //$part3 = host/extension[~expiry]
				$reg['host'] = $ary[0]; //host
				$part22 = $ary[1];  // $part22 = extension[~expiry]
				$ary = explode('~',$part22);
				if(count($ary) == 2) { //$part22 = extension~expiry
					$reg['extension'] = $ary[0]; //extension
					$reg['expiry'] = $ary[1];  //expiry
				} else if(count($ary) == 1) { // $part2 = extension
					$reg['extension'] = $part22;
				}
			} else if(count($ary) == 1) { //$part3 = host[~expiry]
				$ary = explode('~',$part3);
				if(count($ary) == 2) { //$part3 = host~expiry
					$reg['host'] = $ary[0];
					$reg['expiry'] = $ary[1];
				} else if(count($ary) == 1) { //$part3 = host
					$reg['host'] = $part3;
				}
			}
		}
	}

	return isset($reg) ? $reg : NULL;
}
?>
